// ComBase.cpp: implementation of the CComBase class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ComBase.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CComBase::CComBase()
{
	m_bLoopClosed = false;					// interface loop isn't closed

	m_bRealDevices = true;					// no real IL hardware connected over Pilbox
	m_dwLoopTimeout = 500;					// standard timeout for virtual devices in ms
}

CComBase::~CComBase()
{
}

// ------------------------------------------
// Device()
// send IL frame as controller over the loop
// ------------------------------------------

WORD CComBase::Device(WORD wFrame)
{
	ASSERT(m_bDeviceMode == false);			// must be in controller mode

	m_bLoopClosed = false;					// interface loop isn't closed

	if (SendFrame(wFrame))					// data send
	{
		DWORD dwTimeout = m_dwLoopTimeout;	// standard timeout for tcp/ip devices

		if (m_bRealDevices)					// real IL hardware connected over Pilbox
		{
			// wait for returned frame
			// timeouts: 10s for DOE/RDY, 3s for CMD, 1s for IDY
			do
			{
				if (wFrame < 0x400)			// DOE
				{
					dwTimeout = 10000;
					break;
				}
				if ((wFrame & 0x7F4) == 0x494)	// special PILBox frames 494-497 and 49c-49f
				{
					dwTimeout = 500;
					break;
				}
				if (wFrame < 0x500)			// CMD
				{
					dwTimeout = 3000;
					break;
				}
				if (wFrame < 0x600)			// RDY
				{
					dwTimeout = 10000;
					break;
				}
				dwTimeout = 1000;			// IDY
			}
			while (false);
		}

		// receive data
		m_bLoopClosed = ReceiveFrame(wFrame, dwTimeout);
	}
	return wFrame;
}
