// IlpilsimDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Ilpilsim.h"
#include "IlpilsimDlg.h"
#include "TcpIp.h"
#include "TcpServ.h"
#include "PipeServ.h"

#define VERSION   "1.02"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CIlpilsimApp theApp;

#ifdef _DEBUG
LPCTSTR szNoTitle = _T("ILPilsim ")_T(VERSION)_T(" Debug");
#else
LPCTSTR szNoTitle = _T("ILPilsim ")_T(VERSION);
#endif

static const LPCTSTR szLicence =
	_T("This program is free software; you can redistribute it and/or modify\r\n")
	_T("it under the terms of the GNU General Public License as published by\r\n")
	_T("the Free Software Foundation; either version 2 of the License, or\r\n")
	_T("(at your option) any later version.\r\n")
	_T("\r\n")
	_T("This program is distributed in the hope that it will be useful,\r\n")
	_T("but WITHOUT ANY WARRANTY; without even the implied warranty of\r\n")
	_T("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\r\n")
	_T("See the GNU General Public License for more details.\r\n")
	_T("\r\n")
	_T("You should have received a copy of the GNU General Public License along\r\n")
	_T("with this program; if not, write to the Free Software Foundation, Inc.,\r\n")
	_T("51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.");

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_VERSION,szNoTitle);
	SetDlgItemText(IDC_LICENSE,szLicence);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CIlpilsimDlg dialog

CIlpilsimDlg::CIlpilsimDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIlpilsimDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIlpilsimDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// Virtual loop settings
	m_strAddrOut = _T("localhost");
	m_uPortOut   = 60001;
	m_uPortIn    = 60000;

	m_dwConnectTimeout = 0xFFFFFFFF;		// client connect timeout in us (default blocked connect timeout)

	// Controller interface settings
	m_strLinkAddr = _T("59999");

	m_bEnableRFC = TRUE;					// show RFC frames on the virtual loop

	m_pVirtLoop = nullptr;					// virtual loop interface object class
	m_pPilboxSim = nullptr;					// PIL-Box simulation interface
}

/////////////////////////////////////////////////////////////////////////////
// CIlpilsimDlg settings helper functions

CString CIlpilsimDlg::ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR cBuffer[1024];

		::GetPrivateProfileString(lpszSection,lpszEntry,lpszDefault,cBuffer,ARRAYSIZEOF(cBuffer),theApp.m_szIniFile);
		return CString(cBuffer);
	}
	else
	{
		return AfxGetApp()->GetProfileString(lpszSection,lpszEntry,lpszDefault);
	}
}

UINT CIlpilsimDlg::ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::GetPrivateProfileInt(lpszSection,lpszEntry,nDefault,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->GetProfileInt(lpszSection,lpszEntry,nDefault);
	}
}

BOOL CIlpilsimDlg::WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::WritePrivateProfileString(lpszSection,lpszEntry,lpszValue,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileString(lpszSection,lpszEntry,lpszValue);
	}
}

BOOL CIlpilsimDlg::WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR s[16];
		wsprintf(s,_T("%u"),nValue);
		return ::WritePrivateProfileString(lpszSection,lpszEntry,s,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileInt(lpszSection,lpszEntry,nValue);
	}
}

void CIlpilsimDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIlpilsimDlg)
	DDX_Control(pDX, IDC_START, m_CButStart);
	DDX_Control(pDX, IDC_STOP, m_CButStop);
	DDX_Control(pDX, IDC_PAUSE, m_CButPause);
	DDX_Text(pDX, IDC_LINKADDR, m_strLinkAddr);
	DDX_Text(pDX, IDC_ADDR_OUT, m_strAddrOut);
	DDX_Text(pDX, IDC_PORT_OUT, m_uPortOut);
	DDX_Text(pDX, IDC_PORT_IN, m_uPortIn);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIlpilsimDlg, CDialog)
	ON_MESSAGE(WM_INTERFACESTOPPED, OnInterfaceStopped)
	ON_MESSAGE(WM_SERVERSTOPPED, OnServerStopped)

	//{{AFX_MSG_MAP(CIlpilsimDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_PAUSE, OnPause)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIlpilsimDlg message handlers

BOOL CIlpilsimDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "Help Topics..." and "About..." menu items to the system menu.

	// IDM_HELPTOPICS must be in the system command range.
	ASSERT((IDM_HELPTOPICS & 0xFFF0) == IDM_HELPTOPICS);
	ASSERT(IDM_HELPTOPICS < 0xF000);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		CString strText;
		pSysMenu->AppendMenu(MF_SEPARATOR);

		strText.LoadString(IDS_HELP_TOPICS);
		pSysMenu->AppendMenu(MF_STRING, IDM_HELPTOPICS, strText);

		strText.LoadString(IDS_ABOUTBOX);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strText);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_CButStart.EnableWindow(TRUE);
	m_CButStop.EnableWindow(FALSE);
	m_CButPause.EnableWindow(FALSE);

	if (*theApp.m_szIniFile != 0)			// ini file given
	{
		CString strTitle;

		// new document title
		GetWindowText(strTitle);
		strTitle += CString(_T(" - ")) + theApp.m_lpFilePart;
		SetWindowText(strTitle);	// set document title with ini file
	}

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);

	// load positions from registry if available
	m_nPosX       = ReadInt(_T("Settings"),_T("WinPosX"),wndpl.rcNormalPosition.left);
	m_nPosY       = ReadInt(_T("Settings"),_T("WinPosY"),wndpl.rcNormalPosition.top);

	m_strLinkAddr = ReadString(_T("Settings"),_T("LinkAddr"),m_strLinkAddr);
	m_strAddrOut  = ReadString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	m_uPortOut    = ReadInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	m_uPortIn     = ReadInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	m_dwConnectTimeout = ReadInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);
	m_bEnableRFC  = ReadInt(_T("Settings"),_T("EnableRFC"),m_bEnableRFC);

	SetWindowLocation(m_nPosX,m_nPosY);		// set windows location
	UpdateData(FALSE);

	// press the "Start" button
	if (theApp.m_bStart) PostMessage(WM_COMMAND,IDC_START);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CIlpilsimDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE)
	{
		return TRUE;  // disable the ESC key quitting the application
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CIlpilsimDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	switch (nID & 0xFFF0)
	{
	case IDM_HELPTOPICS:
		ShellExecute(GetSafeHwnd(),
					 _T("open"),
					 _T("ILPilsim.htm"),
					 NULL,
					 _T(""),
					 SW_SHOWNORMAL);
		break;
	case IDM_ABOUTBOX:
		CAboutDlg().DoModal();
		break;
	default:
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIlpilsimDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIlpilsimDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// set window location
VOID CIlpilsimDlg::SetWindowLocation(INT nPosX,INT nPosY)
{
	WINDOWPLACEMENT wndpl;
	RECT *pRc = &wndpl.rcNormalPosition;

	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	pRc->right = pRc->right - pRc->left + nPosX;
	pRc->bottom = pRc->bottom - pRc->top + nPosY;
	pRc->left = nPosX;
	pRc->top = nPosY;
	SetWindowPlacement(&wndpl);
	return;
}

void CIlpilsimDlg::OnStart()
{
	// TODO: Add your control notification handler code here
	bool bPilboxSimCreated = false;

	UpdateData(TRUE);

	// the Virtual loop device interface
	ASSERT(m_pVirtLoop == nullptr);
	m_pVirtLoop = new CTcpIp(NULL, m_strAddrOut, m_uPortOut, m_uPortIn, m_dwConnectTimeout, this);

	if (m_pVirtLoop != nullptr)
	{
		if ((bPilboxSimCreated = (m_pPilboxSim == nullptr)))
		{
			// create a new instance of the PIL-Box simulation
			if (m_strLinkAddr.Left(9) == _T("\\\\.\\pipe\\"))
			{
				// named pipe server
				m_pPilboxSim = new CPipeServ(m_pVirtLoop, m_strLinkAddr, this);
			}
			else
			{
				// the TCP/IP port from the emulation link
				UINT uTcpPort = _tcstoul(m_strLinkAddr,NULL,10);

				// TCP/IP server
				m_pPilboxSim = new CTcpServ(m_pVirtLoop, uTcpPort, this);
			}
		}

		if (m_pPilboxSim == nullptr)		// no instance for PIL-Box simulation
		{
			ASSERT(m_pVirtLoop);			// delete virtual loop instance
			delete m_pVirtLoop;
			m_pVirtLoop = nullptr;
		}
	}

	if (m_pVirtLoop != nullptr)				// start the virtual loop server
	{
		// start virtual loop device server
		if (m_pVirtLoop->StartServer() == false)
		{
			ASSERT(m_pVirtLoop);			// delete virtual loop instance
			delete m_pVirtLoop;
			m_pVirtLoop = nullptr;

			ASSERT(m_pPilboxSim);			// delete PIL-Box simulation instance
			delete m_pPilboxSim;
			m_pPilboxSim = nullptr;
		}
	}

	if (m_pPilboxSim != nullptr)			// has instance of PIL-Box server
	{
		m_pPilboxSim->SetEnableRFC(m_bEnableRFC != FALSE);

		if (bPilboxSimCreated)
		{
			// start PIL-Box simulation server
			if (m_pPilboxSim->StartServer() == false)
			{
				ASSERT(m_pPilboxSim);		// delete PIL-Box simulation instance
				delete m_pPilboxSim;
				m_pPilboxSim = nullptr;

				ASSERT(m_pVirtLoop);
				m_pVirtLoop->StopServer();	// server shutdown delete instance
			}
		}
		else
		{
			// PIL-Box simulation server already running, set new virtual loop
			m_pPilboxSim->SetLoopCallback(m_pVirtLoop);
		}
	}

	// both interfaces successful installed
	if (m_pVirtLoop != nullptr && m_pPilboxSim != nullptr)
	{
		m_CButStart.SetButtonStyle(BS_PUSHBUTTON);
		m_CButStart.EnableWindow(FALSE);
		m_CButStop.EnableWindow(TRUE);
		m_CButStop.SetButtonStyle(BS_DEFPUSHBUTTON);
		m_CButStop.SetFocus();
		m_CButPause.EnableWindow(TRUE);

		GetDlgItem(IDC_LINKADDR)->EnableWindow(FALSE);
		GetDlgItem(IDC_ADDR_OUT)->EnableWindow(FALSE);
		GetDlgItem(IDC_PORT_OUT)->EnableWindow(FALSE);
		GetDlgItem(IDC_PORT_IN)->EnableWindow(FALSE);
	}
}

void CIlpilsimDlg::OnStop()
{
	// TODO: Add your control notification handler code here
	if (m_pPilboxSim != nullptr)
	{
		ASSERT(m_pPilboxSim);				// PIL-Box simulation interface
		m_pPilboxSim->StopServer();			// quit server thread
	}

	if (m_pVirtLoop != nullptr)
	{
		ASSERT(m_pVirtLoop);				// loop class
		m_pVirtLoop->StopServer();			// quit server thread
	}

	m_CButStop.SetButtonStyle(BS_PUSHBUTTON);
	m_CButStop.EnableWindow(FALSE);
	m_CButStart.EnableWindow(TRUE);
	m_CButStart.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_CButStart.SetFocus();
	m_CButPause.EnableWindow(FALSE);

	GetDlgItem(IDC_LINKADDR)->EnableWindow(TRUE);
	GetDlgItem(IDC_ADDR_OUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PORT_OUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PORT_IN)->EnableWindow(TRUE);
}

void CIlpilsimDlg::OnPause()
{
	// TODO: Add your control notification handler code here
	m_pPilboxSim->SetLoopCallback(nullptr);

	if (m_pVirtLoop != nullptr)
	{
		ASSERT(m_pVirtLoop);				// loop class
		m_pVirtLoop->StopServer();			// quit server thread
	}

	m_CButPause.SetButtonStyle(BS_PUSHBUTTON);
	m_CButPause.EnableWindow(FALSE);
	m_CButStop.SetButtonStyle(BS_PUSHBUTTON);
	m_CButStop.EnableWindow(TRUE);
	m_CButStart.EnableWindow(TRUE);
	m_CButStart.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_CButStart.SetFocus();

	GetDlgItem(IDC_LINKADDR)->EnableWindow(FALSE);
	GetDlgItem(IDC_ADDR_OUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PORT_OUT)->EnableWindow(TRUE);
	GetDlgItem(IDC_PORT_IN)->EnableWindow(TRUE);
}

//
// Virtual Loop server stopped
//
LRESULT CIlpilsimDlg::OnInterfaceStopped(WPARAM wParam,LPARAM lParam)
{
	// quit message from Interface worker thread
	CInterface *pVirtLoop = reinterpret_cast<CInterface *>(wParam);
	ASSERT(pVirtLoop == m_pVirtLoop);

	ASSERT(m_pVirtLoop);
	delete m_pVirtLoop;
	m_pVirtLoop = nullptr;
	return 0;
	UNREFERENCED_PARAMETER(wParam);
	UNREFERENCED_PARAMETER(lParam);
}

//
// controller (calculator) server stopped
//
LRESULT CIlpilsimDlg::OnServerStopped(WPARAM wParam,LPARAM lParam)
{
	// quit message from PILBox simulation worker thread
	CServer *pPilboxSim = reinterpret_cast<CServer *>(wParam);
	ASSERT(pPilboxSim == m_pPilboxSim);

	ASSERT(m_pPilboxSim);
	delete m_pPilboxSim;
	m_pPilboxSim = nullptr;
	return 0;
	UNREFERENCED_PARAMETER(wParam);
	UNREFERENCED_PARAMETER(lParam);
}

void CIlpilsimDlg::OnCancel()
{
	// TODO: Add extra cleanup here
	if (   m_pVirtLoop != nullptr			// virtual loop interface running
		|| m_pPilboxSim != nullptr)			// PIL-Box simulation interface running
	{
		OnStop();
		PostMessage(WM_COMMAND,IDCANCEL,0);	// call myself, until threads finished
		return;
	}

	// save current settings
	UpdateData(TRUE);

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	m_nPosX = wndpl.rcNormalPosition.left;
	m_nPosY = wndpl.rcNormalPosition.top;

	TCHAR szAppFile[_MAX_PATH];				// full pathname of application
	GetModuleFileName(NULL,szAppFile,ARRAYSIZEOF(szAppFile));
	WriteString(_T("Run"),_T("App"),szAppFile);

	WriteInt(_T("Settings"),_T("WinPosX"),m_nPosX);
	WriteInt(_T("Settings"),_T("WinPosY"),m_nPosY);

	WriteString(_T("Settings"),_T("LinkAddr"),m_strLinkAddr);
	WriteString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	WriteInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	WriteInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	WriteInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);
	WriteInt(_T("Settings"),_T("EnableRFC"),m_bEnableRFC);

	CDialog::OnCancel();
}
