// IlpilsimDlg.h : header file
//

#if !defined(AFX_ILPILSIMDLG_H__20C9183A_133F_4DF0_A024_629D30A51F1A__INCLUDED_)
#define AFX_ILPILSIMDLG_H__20C9183A_133F_4DF0_A024_629D30A51F1A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CInterface;							// Virtual loop interface object class
class CPilBoxSim;							// Controller server

/////////////////////////////////////////////////////////////////////////////
// CIlpilsimDlg dialog

class CIlpilsimDlg : public CDialog
{
// Construction
public:
	CIlpilsimDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CIlpilsimDlg)
	enum { IDD = IDD_ILPILSIM_DIALOG };
	CButton	m_CButStart;
	CButton	m_CButStop;
	CButton	m_CButPause;
	CString	m_strLinkAddr;
	CString	m_strAddrOut;
	UINT	m_uPortOut;
	UINT	m_uPortIn;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIlpilsimDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	LRESULT OnInterfaceStopped(WPARAM wParam,LPARAM lParam);
	LRESULT OnServerStopped(WPARAM wParam,LPARAM lParam);

	// Generated message map functions
	//{{AFX_MSG(CIlpilsimDlg)
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();
	afx_msg void OnStart();
	afx_msg void OnStop();
	afx_msg void OnPause();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	LONG	m_nPosX;						// display position
	LONG	m_nPosY;

	DWORD	m_dwConnectTimeout;				// client connect timeout

	BOOL	m_bEnableRFC;					// enable a RFC behind a CMD frame

	CInterface  *m_pVirtLoop;				// virtual loop interface object class
	CPilBoxSim  *m_pPilboxSim;				// PIL-Box simulation interface

	CString	ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault);
	UINT	ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault);
	BOOL	WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue);
	BOOL	WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue);

	VOID SetWindowLocation(INT nPosX, INT nPosY);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ILPILSIM_H__20C9183A_133F_4DF0_A024_629D30A51F1A__INCLUDED_)
