// PilBoxSim.h: interface for the CPilBoxSim class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PILBOXSIM_H__71B88B50_C073_4F41_AA8C_7FAB8073335C__INCLUDED_)
#define AFX_PILBOXSIM_H__71B88B50_C073_4F41_AA8C_7FAB8073335C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Server.h"

class CPilBoxSim : public CServer
{
public:
	CPilBoxSim(bool bEnableRFC = true);
	virtual ~CPilBoxSim();

	void SetLoopCallback(CIL* pIL);

	void SetEnableRFC(bool bEnableRFC) { m_bEnableRFC = bEnableRFC; }
	bool GetEnableRFC() const          { return m_bEnableRFC; }

protected:
	BYTE PILBox(BYTE byVal);

private:
	CRITICAL_SECTION m_csLock;

	bool    m_bEnableRFC;					// enable a RFC behind a CMD frame
	bool    m_bUSE8BITS;
	BYTE    m_byLastHigh;
	BYTE    m_byLastByte;
	BYTE    m_byTxHigh;
	BYTE    m_byTxLow;
	BYTE    m_byIlFlg;						// IL flags
};

#endif // !defined(AFX_PILBOXSIM_H__71B88B50_C073_4F41_AA8C_7FAB8073335C__INCLUDED_)
