// PipeServ.h: interface for the CPipeServ class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PIPESERV_H__ED2E6867_70AF_43B9_8F1B_A915121D20E1__INCLUDED_)
#define AFX_PIPESERV_H__ED2E6867_70AF_43B9_8F1B_A915121D20E1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PilBoxSim.h"

class CPipeServ : public CPilBoxSim
{
public:
	CPipeServ(CIL *pIL, LPCTSTR lpszPipeName, CWnd* pParent);
	virtual ~CPipeServ();

	bool StartServer() override;
	void StopServer() override;

private:
	typedef struct
	{
		OVERLAPPED oOverlap;
		HANDLE hPipe;
		BYTE  byRequest;
		DWORD cbRead;
		BYTE  byReply;
		DWORD cbToWrite;
		DWORD dwState;
		bool fPendingIO;
	} PIPEINST, *LPPIPEINST;

	PIPEINST m_Pipe;

	CString m_strPipeName;

	void DisconnectAndReconnect();
	bool ConnectToNewClient(HANDLE, LPOVERLAPPED);

	static UINT ThreadPipeServer(LPVOID pParam);
};

#endif // !defined(AFX_PIPESERV_H__ED2E6867_70AF_43B9_8F1B_A915121D20E1__INCLUDED_)
